"use strict";

exports.__esModule = true;
exports.replaceHydrateFunction = void 0;

var _component = require("@loadable/component");

var _semver = require("semver");

const react18 = JSON.stringify((0, _semver.major)(require(`react-dom/package.json`).version) >= 18);

const replaceHydrateFunction = (_, options) => (element, container, callback) => {
  if (react18) {
    const {
      hydrateRoot: hydrate,
      createRoot: render
    } = require(`react-dom/client`);
  } else {
    const {
      hydrate,
      render
    } = require(`react-dom`);
  }

  (0, _component.loadableReady)(() => {
    const renderFn = typeof options.useHydrate === "undefined" ? // Using ReactDOM.hydrate on develop will throw an error in console
    process.env.BUILD_STAGE.includes("develop") ? render : hydrate : !!options.useHydrate ? hydrate : render;
    renderFn(element, container, callback);
  });
};

exports.replaceHydrateFunction = replaceHydrateFunction;